---
title: Configuration
weight: 2
chapter: false
---

## Options Menu ##

<div class="imgBox right"><div>
	<img src="/images/OptionsMenu.png" />
	<span>Options Menu</span>
</div></div>

The options menu contains a number of shortcuts to change some popular settings:

**Speed**: Selects the emulation's current speed.  Also see the [Rewind and Fast Forward shortcut keys](/configuration/preferences.html#shortcut-keys).

**Video Size**: Selects the picture's size -- when fullscreen is selected, the picture will automatically fill the screen. Additionally, you can also manually resize the window to select any size you prefer.

**Video Filter**: Selects a filter to apply to the picture. The `NTSC` filters attempt to reproduce the feeling of old CRT screens, while the other filters are a variety of different techniques used to scale up pixel art. Additional NTSC filter specific settings are available in the [video options](/configuration/video.html#picture).

**Region**: When set to `Auto`, the emulator will try to detect the game's region (NTSC or PAL) - however, this is not always possible.  When there is nothing to suggest a game is for the `PAL` region (Australia & Europe), the `NTSC` region (North America & Japan) will be used by default. `Dendy` is used to mimic a number of different NES clones, in particular, the Dendy, which was a popular clone in Russia.

## Configuration Dialogs ##

Additional settings can be found in each of the available menu options:

* [Audio Options](/configuration/audio.html)
* [Input Options](/configuration/input.html)
* [Video Options](/configuration/video.html)
* [Emulation Options](/configuration/emulation.html)
* [Preferences](/configuration/preferences.html)